camera = {}

local x, y = 0, 0   -- Position
local r = 0         -- Rotation
local zx, zy = 1, 1 -- Zoom (Scale)

function camera:set()
  love.graphics.push()
  love.graphics.rotate(r)
  love.graphics.scale(1/zx, 1/zy)
  love.graphics.translate(-x,-y)
end

function camera:setPosition(nx, ny)
  x = nx or 0
  y = ny or 0
end
function camera:move(dx, dy)
  x = x + (dx or 0)
  y = y + (dy or 0)
end

function camera:setRotation(tr)
  r = tr or 0
end
function camera:rotate(dr)
  r = r + (dr or 0)
end

--NOT YET RECOMMENDED (It doesn't center around a chosen point)
-- MUST Move with x and y
function camera:setZoom(z)
  zx = zx * (z or 1)
  zy = zx * (z or 1)
end

--NOT YET RECOMMENDED (It doesn't center around a chosen point)
-- (+)Zoom In (-) Zoom Out
function camera:zoom(z)
  zx = zx - (z or 0)
  zy = zy - (z or 0)
end

-- Camera Limits
function camera:clampX(min, max)
  if x < min then x = min end
  if x > max then x = max end
end
function camera:clampY(min, max)
  if y < min then y = min end
  if y > max then y = max end
end

function camera:unset()
  love.graphics.pop()
end
