require 'lib/state_machine'
require 'lib/maths'
require 'lib/textinput'
require 'lib/menu'
require 'lib/entities'

require 'src/globals'

require 'src/engine'
require 'src/board'
require 'src/piece'
require 'src/gui_board'
require 'src/gui_piece'
require 'src/player'
require 'src/jang' -- AI

require 'src/state_title'
require 'src/state_hansetup'
require 'src/state_chusetup'
require 'src/state_play'
require 'src/state_pause'
require 'src/state_loadgame'
require 'src/state_savegame'
require 'src/state_analyzematch'
require 'src/state_loadmatch'
require 'src/state_savematch'
require 'src/state_position'
require 'src/state_loadposition'
require 'src/state_saveposition'
require 'src/state_timersettings'
require 'src/timer'
require 'src/state_tutorial'

function love.load()
  love.graphics.setDefaultFilter('nearest', 'nearest')

  state_machine.push(state_title, params)
end

function love.update(dt)
  state_machine.update(dt)
end
function love.draw()
  gui_board.draw()
  state_machine.draw()
end

-- Keyboard Inputs
function love.keypressed(key)
  state_machine.keypressed(key)
end
function love.keyreleased(key)
  state_machine.keyreleased(key)
end
function love.textinput(t)
  state_machine.textinput(t)
end

-- Mouse Functions
function love.mousemoved(x, y, dx, dy)
  state_machine.mousemoved(x, y, dx, dy)
end
function love.mousepressed(x, y, button)
  state_machine.mousepressed(x, y, button)
end
function love.mousereleased(x, y, button)
  state_machine.mousereleased(x, y, button)
end
function love.wheelmoved(x, y)
  state_machine.wheelmoved(x, y)
end


