state_chusetup = newState()

local font = love.graphics.newFont(30)
local text = 'Choose a Setup for Chu'
local menu = newMenu(love.graphics.newFont(20), 5, {1, 1, 1}, {0,100/255,0,0.75})
local gui_pieces = {}
local chu_row = ''
local han_row = ''
local han_gui_pieces = {}
local ai = 0

menu.addButton('1', gui_board.points[engine.getIndex(4,3)].x, gui_board.points[engine.getIndex(4,3)].y,
  function()
    gui_pieces[1].changeTarget(gui_board.points[84].x, love.graphics.getHeight() + gui_pieces[1].size)
    gui_pieces[2].changeTarget(gui_board.points[83].x, gui_board.points[83].y)
    gui_pieces[3].changeTarget(gui_board.points[84].x, gui_board.points[84].y)
    gui_pieces[4].changeTarget(gui_board.points[88].x, gui_board.points[88].y)
    gui_pieces[5].changeTarget(gui_board.points[89].x, gui_board.points[89].y)
    gui_pieces[6].changeTarget(gui_board.points[88].x, love.graphics.getHeight() + gui_pieces[1].size)
    chu_row = 'THEA AEHT'
  end
)
menu.addButton('2', gui_board.points[engine.getIndex(4,4)].x, gui_board.points[engine.getIndex(4,4)].y,
  function()
    gui_pieces[1].changeTarget(gui_board.points[84].x, love.graphics.getHeight() + gui_pieces[1].size)
    gui_pieces[2].changeTarget(gui_board.points[84].x, gui_board.points[84].y)
    gui_pieces[3].changeTarget(gui_board.points[83].x, gui_board.points[83].y)
    gui_pieces[4].changeTarget(gui_board.points[89].x, gui_board.points[89].y)
    gui_pieces[5].changeTarget(gui_board.points[88].x, gui_board.points[88].y)
    gui_pieces[6].changeTarget(gui_board.points[88].x, love.graphics.getHeight() + gui_pieces[1].size)  
    chu_row = 'TEHA AHET'
  end
)
menu.addButton('3', gui_board.points[engine.getIndex(4,5)].x, gui_board.points[engine.getIndex(4,5)].y,
  function()
    gui_pieces[1].changeTarget(gui_board.points[84].x, love.graphics.getHeight() + gui_pieces[1].size)
    gui_pieces[2].changeTarget(gui_board.points[83].x, gui_board.points[83].y)
    gui_pieces[3].changeTarget(gui_board.points[84].x, gui_board.points[84].y)
    gui_pieces[4].changeTarget(gui_board.points[89].x, gui_board.points[89].y)
    gui_pieces[5].changeTarget(gui_board.points[88].x, gui_board.points[88].y)
    gui_pieces[6].changeTarget(gui_board.points[88].x, love.graphics.getHeight() + gui_pieces[1].size)  
    chu_row = 'THEA AHET'
  end
)
menu.addButton('4', gui_board.points[engine.getIndex(4,6)].x, gui_board.points[engine.getIndex(4,6)].y,
  function()
    gui_pieces[1].changeTarget(gui_board.points[84].x, love.graphics.getHeight() + gui_pieces[1].size)
    gui_pieces[2].changeTarget(gui_board.points[84].x, gui_board.points[84].y)
    gui_pieces[3].changeTarget(gui_board.points[83].x, gui_board.points[83].y)
    gui_pieces[4].changeTarget(gui_board.points[88].x, gui_board.points[88].y)
    gui_pieces[5].changeTarget(gui_board.points[89].x, gui_board.points[89].y)
    gui_pieces[6].changeTarget(gui_board.points[88].x, love.graphics.getHeight() + gui_pieces[1].size)  
    chu_row = 'TEHA AEHT'
  end
)
menu.addButton('5', gui_board.points[engine.getIndex(4,7)].x, gui_board.points[engine.getIndex(4,7)].y,
  function()
    gui_pieces[1].changeTarget(gui_board.points[84].x, gui_board.points[84].y)
    gui_pieces[2].changeTarget(gui_board.points[83].x, gui_board.points[83].y)
    gui_pieces[3].changeTarget(gui_board.points[82].x, gui_board.points[82].y)
    gui_pieces[4].changeTarget(gui_board.points[90].x, gui_board.points[90].y)
    gui_pieces[5].changeTarget(gui_board.points[89].x, gui_board.points[89].y)
    gui_pieces[6].changeTarget(gui_board.points[88].x, gui_board.points[88].y)  
    chu_row = 'EHTA ATHE'
  end
)
menu.addButton('OK', gui_board.points[engine.getIndex(7,5)].x, gui_board.points[engine.getIndex(7,5)].y,
  function()
    local rep = han_row .. '4g4' .. '1c5c1' .. 's s s s s' .. '99' .. 'S S S S S' .. '1C5C1' .. '4G4' .. chu_row
    local data = {}
    if love.filesystem.getInfo('timer.cfg') then
      for line in love.filesystem.lines('timer.cfg') do
        table.insert(data, line)
      end
    end
    local timerstatus = #data > 0 and data[1] or 'off'
    state_machine.change(state_play, {rep = rep, turn_counter = 1, evaluate = true, ai = ai, timerstatus = timerstatus})
  end
)

function state_chusetup.load(params)
  gui_board.load()
  chu_row = 'THEA AEHT'
  han_row = params.han_row
  han_gui_pieces = params.han_pieces
  ai = params.ai
  
  gui_pieces = {}
  table.insert(gui_pieces, newGuiPiece('T', 82)) gui_pieces[1].setPosition(gui_board.points[84].x, love.graphics.getHeight() + gui_pieces[1].size)
  table.insert(gui_pieces, newGuiPiece('H', 83)) gui_pieces[2].setPosition(gui_board.points[83].x, gui_board.points[83].y)
  table.insert(gui_pieces, newGuiPiece('E', 84)) gui_pieces[3].setPosition(gui_board.points[84].x, gui_board.points[84].y)
  table.insert(gui_pieces, newGuiPiece('E', 88)) gui_pieces[4].setPosition(gui_board.points[88].x, gui_board.points[88].y)
  table.insert(gui_pieces, newGuiPiece('H', 89)) gui_pieces[5].setPosition(gui_board.points[89].x, gui_board.points[89].y)
  table.insert(gui_pieces, newGuiPiece('T', 90)) gui_pieces[6].setPosition(gui_board.points[88].x, love.graphics.getHeight() + gui_pieces[1].size)
end

function state_chusetup.update(dt)
  for _, v in pairs(gui_pieces) do
    v.update(dt)
  end
end

function state_chusetup.draw()
  love.graphics.setFont(font)
  love.graphics.print(text , gui_board.points[5].x - (font:getWidth(text) / 2), love.graphics.getHeight() / 2)
  
  for _, v in pairs(han_gui_pieces) do
    v.draw()
  end
  
  for _, v in pairs(gui_pieces) do
    v.draw()
  end
  
  menu.draw()
end

function state_chusetup.mousemoved(x, y, dx, dy)
  menu.mouse_over(x, y)
end
function state_chusetup.mousepressed(x, y, button)
  if button == 1 then
    menu.button_press()
  end
end
function state_chusetup.mousereleased(x, y, button)
  if button == 1 then
    menu.button_release()
  end
end
--]]
