state_hansetup = newState()

local font = love.graphics.newFont(30)
local text = 'Choose a Setup for Han'
local menu = newMenu(love.graphics.newFont(20), 5, {1, 1, 1}, {100/255,0,0,0.75})
local gui_pieces = {}
local han_row = ''
local ai = 0

menu.addButton('1', gui_board.points[engine.getIndex(4,3)].x, gui_board.points[engine.getIndex(4,3)].y,
  function()
    gui_pieces[1].changeTarget(gui_board.points[3].x, -gui_pieces[1].size)
    gui_pieces[2].changeTarget(gui_board.points[2].x, gui_board.points[2].y)
    gui_pieces[3].changeTarget(gui_board.points[3].x, gui_board.points[3].y)
    gui_pieces[4].changeTarget(gui_board.points[7].x, gui_board.points[7].y)
    gui_pieces[5].changeTarget(gui_board.points[8].x, gui_board.points[8].y)
    gui_pieces[6].changeTarget(gui_board.points[7].x, -gui_pieces[1].size)
    han_row = 'thea aeht'
  end
)
menu.addButton('2', gui_board.points[engine.getIndex(4,4)].x, gui_board.points[engine.getIndex(4,4)].y,
  function()
    gui_pieces[1].changeTarget(gui_board.points[3].x, -gui_pieces[1].size)
    gui_pieces[2].changeTarget(gui_board.points[3].x, gui_board.points[3].y)
    gui_pieces[3].changeTarget(gui_board.points[2].x, gui_board.points[2].y)
    gui_pieces[4].changeTarget(gui_board.points[8].x, gui_board.points[8].y)
    gui_pieces[5].changeTarget(gui_board.points[7].x, gui_board.points[7].y)
    gui_pieces[6].changeTarget(gui_board.points[7].x, -gui_pieces[1].size)  
    han_row = 'teha ahet'
  end
)
menu.addButton('3', gui_board.points[engine.getIndex(4,5)].x, gui_board.points[engine.getIndex(4,5)].y,
  function()
    gui_pieces[1].changeTarget(gui_board.points[3].x, -gui_pieces[1].size)
    gui_pieces[2].changeTarget(gui_board.points[2].x, gui_board.points[2].y)
    gui_pieces[3].changeTarget(gui_board.points[3].x, gui_board.points[3].y)
    gui_pieces[4].changeTarget(gui_board.points[8].x, gui_board.points[8].y)
    gui_pieces[5].changeTarget(gui_board.points[7].x, gui_board.points[7].y)
    gui_pieces[6].changeTarget(gui_board.points[7].x, -gui_pieces[1].size)  
    han_row = 'thea ahet'
  end
)
menu.addButton('4', gui_board.points[engine.getIndex(4,6)].x, gui_board.points[engine.getIndex(4,6)].y,
  function()
    gui_pieces[1].changeTarget(gui_board.points[3].x, -gui_pieces[1].size)
    gui_pieces[2].changeTarget(gui_board.points[3].x, gui_board.points[3].y)
    gui_pieces[3].changeTarget(gui_board.points[2].x, gui_board.points[2].y)
    gui_pieces[4].changeTarget(gui_board.points[7].x, gui_board.points[7].y)
    gui_pieces[5].changeTarget(gui_board.points[8].x, gui_board.points[8].y)
    gui_pieces[6].changeTarget(gui_board.points[7].x, -gui_pieces[1].size)  
    han_row = 'teha aeht'
  end
)
menu.addButton('5', gui_board.points[engine.getIndex(4,7)].x, gui_board.points[engine.getIndex(4,7)].y,
  function()
    gui_pieces[1].changeTarget(gui_board.points[3].x, gui_board.points[3].y)
    gui_pieces[2].changeTarget(gui_board.points[2].x, gui_board.points[2].y)
    gui_pieces[3].changeTarget(gui_board.points[1].x, gui_board.points[1].y)
    gui_pieces[4].changeTarget(gui_board.points[9].x, gui_board.points[9].y)
    gui_pieces[5].changeTarget(gui_board.points[8].x, gui_board.points[8].y)
    gui_pieces[6].changeTarget(gui_board.points[7].x, gui_board.points[7].y)  
    han_row = 'ehta athe'
  end
)
menu.addButton('OK', gui_board.points[engine.getIndex(7,5)].x, gui_board.points[engine.getIndex(7,5)].y,
  function()
    state_machine.change(state_chusetup, { han_row = han_row, han_pieces = gui_pieces, ai = ai})
  end
)

function state_hansetup.load(artificial_turn)
  gui_board.load()
  han_row = 'thea aeht'
  ai = artificial_turn or 0

  gui_pieces = {}
  table.insert(gui_pieces, newGuiPiece('t', 1)) gui_pieces[1].setPosition(gui_board.points[3].x, -gui_pieces[1].size)
  table.insert(gui_pieces, newGuiPiece('h', 2)) gui_pieces[2].setPosition(gui_board.points[2].x, gui_board.points[2].y)
  table.insert(gui_pieces, newGuiPiece('e', 3)) gui_pieces[3].setPosition(gui_board.points[3].x, gui_board.points[3].y)
  table.insert(gui_pieces, newGuiPiece('e', 7)) gui_pieces[4].setPosition(gui_board.points[7].x, gui_board.points[7].y)
  table.insert(gui_pieces, newGuiPiece('h', 8)) gui_pieces[5].setPosition(gui_board.points[8].x, gui_board.points[8].y)
  table.insert(gui_pieces, newGuiPiece('t', 9)) gui_pieces[6].setPosition(gui_board.points[7].x, -gui_pieces[1].size)
end

function state_hansetup.update(dt)
  for _, v in pairs(gui_pieces) do
    v.update(dt)
  end
end

function state_hansetup.draw()
  love.graphics.setFont(font)
  love.graphics.print(text , gui_board.points[5].x - (font:getWidth(text) / 2), love.graphics.getHeight() / 2)
  
  for _, v in pairs(gui_pieces) do
    v.draw()
  end
  
  menu.draw()
end

function state_hansetup.mousemoved(x, y, dx, dy)
  menu.mouse_over(x, y)
end
function state_hansetup.mousepressed(x, y, button)
  if button == 1 then
    menu.button_press()
  end
end
function state_hansetup.mousereleased(x, y, button)
  if button == 1 then
    menu.button_release()
  end
end
--]]
