state_loadposition = newState()

local bx = 10
local by = 35
local bw = 580
local bh = 550
local list = {}

local row_height = 20
local cols = 5
local col_width = 115
local selector = { x = 0, y = 0, index = 0}

local function loadList()
  local items = love.filesystem.getDirectoryItems('')
  list = {}
  for _, v in pairs(items) do
    if v:sub(-4) == '.pos' then
      local i = #list+1
      local row = math.ceil(i/cols)
      local col = ((i-1)%cols)+1
      table.insert(list, {filename = v:sub(1,#v-4), x = bx + 5 + (col-1) * col_width, y = by + 5 + (row-1) * row_height})
    end
  end
  
  selector.index = 0
end

local deleter = newGSubMenu()
deleter.addButton('x', 0, 0, function()
    love.filesystem.remove(list[selector.index].filename .. '.pos')
    loadList()
  end
)

function state_loadposition.load()
  loadList()
end

function state_loadposition.draw()
  love.graphics.setColor(0,0,0,0.4)
  love.graphics.rectangle('fill', bx, by, bw, bh, 4, 4)
  
  love.graphics.setColor(1,1,1)
  for i, v in pairs(list) do
    love.graphics.print(v.filename, v.x, v.y)
  end
  
  if selector.index > 0 then
    love.graphics.setColor(1,1,1,0.3)
    love.graphics.rectangle('fill', selector.x, selector.y, col_width-12, row_height)
    deleter.draw()
  end
end

function state_loadposition.mousemoved(x, y, dx, dy)
  selector.index = 0
  for i, v in pairs(list) do
    if getCircleRectangleDistance(x, y, 1, v.x, v.y, col_width, row_height) < 0 then
      selector.x = v.x
      selector.y = v.y
      selector.index = i
      deleter.buttons[1].x = selector.x + col_width - 6
      deleter.buttons[1].y = selector.y + 10
    end
  end
  if selector.index > 0 then
    deleter.mouse_over(x, y)
  end
end
function state_loadposition.mousepressed(x, y, button)
  if button == 2 or x < bx or y < by or x > bx + bw or y > by + bh then
    state_machine.pop()
  elseif button == 1 and selector.index > 0 then
    deleter.button_press()
  end
end
function state_loadposition.mousereleased(x, y, button)
  if button == 1 and selector.index > 0 then
    deleter.button_release()
    if selector.index > 0 then
      local rep = love.filesystem.read('string', list[selector.index].filename .. '.pos')
      state_machine.change(state_position, rep)
    end
  end
end
