state_savegame = newState()

local font = love.graphics.newFont(20)
local input = newTextInput(font, 30, 100, 15)
local bx = 10
local by = 35
local bw = 345
local bh = 150
local player1 = ''
local player2 = ''
local rep = ''
local move_history = {}
local turn_counter = 0
local ai

local menu = newMenu(font, 5, {1, 1, 1}, {90/255,0,90/255,0.6})
menu.addButton('OK',     135, 155, function()
    -- Input Some Initial Data
    local data = player1 .. '\n' ..
                 player2 .. '\n' ..
                 rep .. '\n' ..
                 turn_counter .. '\n' ..
                 ai .. '\n'
                 
    -- Inputting the Move History
    for i = 1, #move_history do
      local char = move_history[i].char
      -- Just adding 0 to 1-digit numbers
      local from = move_history[i].from < 10 and '0' .. move_history[i].from or move_history[i].from
      local to = move_history[i].to < 10 and '0' .. move_history[i].to or move_history[i].to
      
      data = data .. char .. from .. to .. '\n'
    end
    
    love.filesystem.write(input.text .. '.gam', data)
    state_machine.pop()
  end
)
menu.addButton('Cancel', 225, 155, function() state_machine.pop() end)

function state_savegame.load(vars)
  player1 = vars.player1
  player2 = vars.player2
  rep = vars.representation
  move_history = vars.move_history
  turn_counter = vars.turn_counter
  ai = vars.ai
  
  local i = 1
  while love.filesystem.getInfo('Game ' .. i .. '.gam') do
    i = i + 1
  end
  
  input.text = 'Game ' .. i
end

function state_savegame.draw()
  love.graphics.setFont(font)
  love.graphics.setColor(0,0,0,0.4)
  love.graphics.rectangle('fill', bx, by, bw, bh, 3, 3)
  love.graphics.setColor(1,1,1)
  love.graphics.printf('Save Game', bx, 45, bw, 'center')
  input.draw()
  
  menu.draw()
end

function state_savegame.keypressed(key)
  input.keypressed(key)
  
  if key == 'escape' then
    state_machine.pop()
  end
end

function state_savegame.textinput(t)
  input.textinput(t)
end

function state_savegame.mousemoved(x, y, dx, dy)
  menu.mouse_over(x, y)
end
function state_savegame.mousepressed(x, y, button)
  if button == 2 or x < bx or y < by or x > bx + bw or y > by + bh then
    state_machine.pop()
  elseif button == 1 then
    menu.button_press()
  end
end
function state_savegame.mousereleased(x, y, button)
  if button == 1 then
    menu.button_release()
  end
end
