state_saveposition = newState()

local font = love.graphics.newFont(20)
local input = newTextInput(font, 30, 100, 15)
local bx = 10
local by = 35
local bw = 345
local bh = 150
local menu = newMenu(font, 5, {1, 1, 1}, {90/255,0,90/255,0.6})
local rep = ''
menu.addButton('OK',     135, 155, function()
    love.filesystem.write(input.text .. '.pos', rep)
    state_machine.pop()
  end
)
menu.addButton('Cancel', 225, 155, function() state_machine.pop() end)

function state_saveposition.load(representation)
  rep = representation
  
  local i = 1
  while love.filesystem.getInfo('Position ' .. i .. '.pos') do
    i = i + 1
  end
  
  input.text = 'Position ' .. i
end

function state_saveposition.draw()
  love.graphics.setFont(font)
  love.graphics.setColor(0,0,0,0.4)
  love.graphics.rectangle('fill', bx, by, bw, bh, 3, 3)
  love.graphics.setColor(1,1,1)
  love.graphics.printf('Save Position', bx, 45, bw, 'center')
  input.draw()
  
  menu.draw()
end

function state_saveposition.keypressed(key)
  input.keypressed(key)
  
  if key == 'escape' then
    state_machine.pop()
  end
end

function state_saveposition.textinput(t)
  input.textinput(t)
end

function state_saveposition.mousemoved(x, y, dx, dy)
  menu.mouse_over(x, y)
end
function state_saveposition.mousepressed(x, y, button)
  if button == 2 or x < bx or y < by or x > bx + bw or y > by + bh then
    state_machine.pop()
  elseif button == 1 then
    menu.button_press()
  end
end
function state_saveposition.mousereleased(x, y, button)
  if button == 1 then
    menu.button_release()
  end
end
