state_title = newState()

local menu = newGMenu()
local submenu_game = newGSubMenu()
local submenu_position = newGSubMenu()

menu.addButton('Game', 58, 15, function() submenu_game.visible = true end)
  submenu_game.addButton('Human vs Computer', 72,  38, function() state_machine.change(state_hansetup, 2) end)
  submenu_game.addButton('Computer vs Human', 72,  59, function() state_machine.change(state_hansetup, 1) end)
  submenu_game.addButton('Human vs Human',    72,  80, function() state_machine.change(state_hansetup)    end)
  submenu_game.addButton('Load',              72, 101, function() state_machine.push(state_loadgame)      end)
  submenu_game.addButton('Analyze a Match',   72, 122, function() state_machine.push(state_loadmatch)     end)
menu.addButton('Board Editor',165,  15, function() submenu_position.visible = true end)
  submenu_position.addButton('Create Position', 164, 38, function() state_machine.change(state_position)   end)
  submenu_position.addButton('Load Position',   164, 59, function() state_machine.push(state_loadposition) end)
menu.addButton('Timer Settings',  272, 15, function() state_machine.push(state_timersettings)    end)
menu.addButton('How to Play', 379, 15, function() state_machine.change(state_tutorial) end)
menu.addButton('Quit',     486, 15, function() love.event.quit()                    end)

function state_title.load()
  gui_board.load()
end

function state_title.draw()
  menu.draw()
  if submenu_game.visible then
    submenu_game.draw()
  end
  if submenu_position.visible then
    submenu_position.draw()
  end
end


function state_title.mousemoved(x, y, dx, dy)
  menu.mouse_over(x, y)
  if submenu_game.visible then
    submenu_game.mouse_over(x, y)
  end
  if submenu_position.visible then
    submenu_position.mouse_over(x, y)
  end
end
function state_title.mousepressed(x, y, button)
  if button == 1 then
    menu.button_press()
    if submenu_game.visible then
      submenu_game.button_press()
    end
    if submenu_position.visible then
      submenu_position.button_press()
    end
  end
end
function state_title.mousereleased(x, y, button)
  if button == 1 then
    if submenu_game.visible then
      submenu_game.visible = false
      submenu_game.button_release()
    end
    if submenu_position.visible then
      submenu_position.visible = false
      submenu_position.button_release()
    end
    menu.button_release()
  end
end
