state_tutorial = newState()

local gui_pieces = {}
local yellow_circles = {}
local lines = {}
local red_circles = {}
local red_lines = {}
local text = ''
local radius = 8
local nexter = newGMenu()
nexter.addButton('Next', gui_board.points[5].x, 500)
nexter.visible = false

local function clear(message)
  gui_pieces = {}
  yellow_circles = {}
  red_lines = {}
  lines = {}
  red_circles = {}
  text = message
  nexter.visible = false
end

local function soldier3()
  clear("They don't get promoted at all. So if they reach the last rank, they're basically stuck in that rank.")
  local index = 6
  local gui_piece = newGuiPiece('S', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)
  table.insert(gui_pieces, gui_piece)
  
  table.insert(yellow_circles, index-1)
  table.insert(yellow_circles, index+1)
end
local function soldier2()
  clear('And they can move 1 space along the Fortress lines... again never retreating.')

  local index = 24
  local gui_piece = newGuiPiece('S', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)
  table.insert(gui_pieces, gui_piece)

  table.insert(yellow_circles, index-1)
  table.insert(yellow_circles, index+1)
  table.insert(yellow_circles, index-9)
  table.insert(yellow_circles, index-10)

  nexter.visible = true
  nexter.buttons[1].fn = function() soldier3() end
end
local function soldier1()
  clear('Soldiers can move 1 space forward or sideways... never retreating.')
  local index = 40
  local gui_piece = newGuiPiece('S', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)
  table.insert(gui_pieces, gui_piece)
  table.insert(yellow_circles, index-1)
  table.insert(yellow_circles, index+1)
  table.insert(yellow_circles, index-9)
  nexter.visible = true
  nexter.buttons[1].fn = function() soldier2() end
end

local function adviser2()
  clear("If there are no lines connecting the points, they can't move there.")
  local index = 5
  local gui_piece = newGuiPiece('A', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)  
  table.insert(gui_pieces, gui_piece)
  table.insert(yellow_circles, index - 1)
  table.insert(yellow_circles, index + 1)
  table.insert(red_circles, index + 8)
  table.insert(yellow_circles, index + 9)
  table.insert(red_circles, index + 10)  
end

local function adviser1()
  clear('Advisers are limited to moving 1 space along the Fortress lines')
  local index = 14
  local gui_piece = newGuiPiece('A', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)  
  table.insert(gui_pieces, gui_piece)
  table.insert(yellow_circles, index - 10)
  table.insert(yellow_circles, index - 9)
  table.insert(yellow_circles, index - 8)
  table.insert(yellow_circles, index - 1)
  table.insert(yellow_circles, index + 1)
  table.insert(yellow_circles, index + 8)
  table.insert(yellow_circles, index + 9)
  table.insert(yellow_circles, index + 10)
  nexter.visible = true
  nexter.buttons[1].fn = function() adviser2() end
end

local function general2()
  clear("If there are no lines connecting the points, they can't move there.")
  local index = 5
  local gui_piece = newGuiPiece('G', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)  
  table.insert(gui_pieces, gui_piece)
  table.insert(yellow_circles, index - 1)
  table.insert(yellow_circles, index + 1)
  table.insert(red_circles, index + 8)
  table.insert(yellow_circles, index + 9)
  table.insert(red_circles, index + 10)  
end

local function general1()
  clear('Generals are limited to moving 1 space along the Fortress lines')
  local index = 14
  local gui_piece = newGuiPiece('G', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)  
  table.insert(gui_pieces, gui_piece)
  table.insert(yellow_circles, index - 10)
  table.insert(yellow_circles, index - 9)
  table.insert(yellow_circles, index - 8)
  table.insert(yellow_circles, index - 1)
  table.insert(yellow_circles, index + 1)
  table.insert(yellow_circles, index + 8)
  table.insert(yellow_circles, index + 9)
  table.insert(yellow_circles, index + 10)
  nexter.visible = true
  nexter.buttons[1].fn = function() general2() end
end

local function chariot2()
  clear('They can also move along the Fortress Lines')
  local index = 6
  local gui_piece = newGuiPiece('T', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)
  table.insert(gui_pieces, gui_piece)
  
  local i = index
  repeat
    i = i + 9
    table.insert(yellow_circles, i)
  until engine.getRank(i) == 10
  i = index
  repeat
    i = i - 1
    table.insert(yellow_circles, i)
  until engine.getFile(i) == 1
  i = index
  repeat
    i = i + 1
    table.insert(yellow_circles, i)
  until engine.getFile(i) == 9
  table.insert(yellow_circles, index + 8)
  table.insert(yellow_circles, index + 16)

end

local function chariot1()
  clear('Chariots move along the unblocked files and ranks.')
  local index = 29
  local gui_piece = newGuiPiece('T', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)
  table.insert(gui_pieces, gui_piece)
  local i = index
  repeat
    i = i - 9
    table.insert(yellow_circles, i)
  until engine.getRank(i) == 1
  i = index
  repeat
    i = i + 9
    table.insert(yellow_circles, i)
  until engine.getRank(i) == 10
  i = index
  repeat
    i = i - 1
    table.insert(yellow_circles, i)
  until engine.getFile(i) == 1
  i = index
  repeat
    i = i + 1
    table.insert(yellow_circles, i)
  until engine.getFile(i) == 9
  
  nexter.visible = true
  nexter.buttons[1].fn = function() chariot2() end  
end

local function horse2()
  clear("If something (friend or foe) blocks that path, they can't move to their targets")
  local index = 41
  local gui_piece = newGuiPiece('H', index) gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)
  local gui_piece2 = newGuiPiece('s', index+9) gui_piece2.setPosition(gui_board.points[index+9].x, gui_board.points[index+9].y)
  local gui_piece3 = newGuiPiece('S', index+1) gui_piece3.setPosition(gui_board.points[index+1].x, gui_board.points[index+1].y)

  table.insert(gui_pieces, gui_piece)
  table.insert(gui_pieces, gui_piece2)
  table.insert(gui_pieces, gui_piece3)

  table.insert(lines, {first = index + 9, last = index - 9})
  table.insert(lines, {first = index + 1, last = index - 1})
  table.insert(lines, {first = index - 9, last = index - 17}) table.insert(yellow_circles, index-17)
  table.insert(lines, {first = index - 9, last = index - 19}) table.insert(yellow_circles, index-19)  
  table.insert(lines, {first = index - 1, last = index - 11}) table.insert(yellow_circles, index - 11)
  table.insert(lines, {first = index - 1, last = index + 7})  table.insert(yellow_circles, index + 7)  
  
  table.insert(red_lines, {first = index + 1, last = index - 7})
  table.insert(red_lines, {first = index + 1, last = index + 11})
  table.insert(red_lines, {first = index + 9, last = index + 19})
  table.insert(red_lines, {first = index + 9, last = index + 17})
  
  table.insert(red_circles, index + 17)
  table.insert(red_circles, index + 19)
  table.insert(red_circles, index - 7)
  table.insert(red_circles, index + 11)
end

local function horse1()
  clear('Horses move in a path: 1 space orthogonally, then 1 space diagonally out.')

  local index = 41
  local gui_piece = newGuiPiece('H', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)

  table.insert(gui_pieces, gui_piece)
  
  table.insert(lines, {first = index + 9, last = index - 9})
  table.insert(lines, {first = index + 1, last = index - 1})

  table.insert(lines, {first = index + 9, last = index + 17}) table.insert(yellow_circles, index+17)
  table.insert(lines, {first = index + 9 ,last = index + 19}) table.insert(yellow_circles, index+19)
  
  table.insert(lines, {first = index - 9, last = index - 17}) table.insert(yellow_circles, index-17)
  table.insert(lines, {first = index - 9, last = index - 19}) table.insert(yellow_circles, index-19)
  
  table.insert(lines, {first = index - 1, last = index - 11}) table.insert(yellow_circles, index - 11)
  table.insert(lines, {first = index - 1, last = index + 7})  table.insert(yellow_circles, index + 7)
  
  table.insert(lines, {first = index + 1, last = index - 7})  table.insert(yellow_circles, index - 7)
  table.insert(lines, {first = index + 1, last = index + 11}) table.insert(yellow_circles, index + 11)

  nexter.visible = true
  nexter.buttons[1].fn = function() horse2() end  
end

local function elephant2()
  clear("If something (friend or foe) blocks that path, they can't move to their targets")

  local index = 41
  local gui_piece = newGuiPiece('E', index) gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)
  local gui_piece2 = newGuiPiece('s', index+1) gui_piece2.setPosition(gui_board.points[index+1].x, gui_board.points[index+1].y)
  local gui_piece3 = newGuiPiece('S', index-11) gui_piece3.setPosition(gui_board.points[index-11].x, gui_board.points[index-11].y)

  table.insert(gui_pieces, gui_piece)
  table.insert(gui_pieces, gui_piece2)
  table.insert(gui_pieces, gui_piece3)
  
  table.insert(lines, {first = index + 9, last = index - 9})
  table.insert(lines, {first = index + 1, last = index - 1})

  table.insert(lines, {first = index + 9, last = index + 25}) table.insert(yellow_circles, index+25)
  table.insert(lines, {first = index + 9 ,last = index + 29}) table.insert(yellow_circles, index+29)
  
  table.insert(lines, {first = index - 9, last = index - 25}) table.insert(yellow_circles, index-25)
  table.insert(lines, {first = index - 9, last = index - 29}) table.insert(yellow_circles, index-29)
  
  table.insert(lines, {first = index - 1, last = index + 15}) table.insert(yellow_circles, index + 15)
  table.insert(lines, {first = index - 1, last = index - 11}) table.insert(red_circles, index - 21)
  table.insert(red_lines, {first = index - 11, last = index - 21})
  
  table.insert(red_lines, {first = index + 1, last = index - 15}) table.insert(red_circles, index -15)
  table.insert(red_lines, {first = index + 1, last = index + 21}) table.insert(red_circles, index + 21)

end
local function elephant1()
  clear('Elephants move in a path: 1 space orthogonally, then 2 spaces diagonally out.')

  local index = 41
  local gui_piece = newGuiPiece('E', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)
  table.insert(gui_pieces, gui_piece)
  
  table.insert(lines, {first = index + 9, last = index - 9})
  table.insert(lines, {first = index + 1, last = index - 1})

  table.insert(lines, {first = index + 9, last = index + 25}) table.insert(yellow_circles, index+25)
  table.insert(lines, {first = index + 9 ,last = index + 29}) table.insert(yellow_circles, index+29)
  
  table.insert(lines, {first = index - 9, last = index - 25}) table.insert(yellow_circles, index-25)
  table.insert(lines, {first = index - 9, last = index - 29}) table.insert(yellow_circles, index-29)
  
  table.insert(lines, {first = index - 1, last = index + 15}) table.insert(yellow_circles, index + 15)
  table.insert(lines, {first = index - 1, last = index - 21}) table.insert(yellow_circles, index - 21)
  
  table.insert(lines, {first = index + 1, last = index - 15})  table.insert(yellow_circles, index -15)
  table.insert(lines, {first = index + 1, last = index + 21}) table.insert(yellow_circles, index + 21)

  nexter.visible = true
  nexter.buttons[1].fn = function() elephant2() end  
end

local function cannon4()
  clear("#3 - They can't jump over or capture other Cannons. This last part makes it confusing.")

  local index = 41
  local gui_piece = newGuiPiece('C', index) gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)
  local gui_piece2 = newGuiPiece('S', 23) gui_piece2.setPosition(gui_board.points[23].x, gui_board.points[23].y)
  local gui_piece3 = newGuiPiece('c', 43) gui_piece3.setPosition(gui_board.points[43].x, gui_board.points[43].y)
  local gui_piece4 = newGuiPiece('c', 5)  gui_piece4.setPosition(gui_board.points[5].x, gui_board.points[5].y)
  local gui_piece5 = newGuiPiece('C', 38) gui_piece5.setPosition(gui_board.points[38].x, gui_board.points[38].y)

  table.insert(gui_pieces, gui_piece)
  table.insert(gui_pieces, gui_piece2)
  table.insert(gui_pieces, gui_piece3)
  table.insert(gui_pieces, gui_piece4)
  table.insert(gui_pieces, gui_piece5)
  
  table.insert(yellow_circles, 14)
  table.insert(red_circles, 5)
  table.insert(red_circles, 44)
  table.insert(red_circles, 45)
  table.insert(red_circles, 37)

  table.insert(gui_pieces, gui_piece)

end

local function cannon3()
  clear('#2 - They can move along the Fortress Lines')

  local index = 6
  local gui_piece = newGuiPiece('C', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)
  local gui_piece2 = newGuiPiece('A', 14) gui_piece2.setPosition(gui_board.points[14].x, gui_board.points[14].y)
  
  table.insert(gui_pieces, gui_piece)
  table.insert(gui_pieces, gui_piece2)
  table.insert(yellow_circles, 22)

  nexter.visible = true
  nexter.buttons[1].fn = function() cannon4() end   
end

local function cannon2()
  clear('#1 - They must jump another piece (friend or foe) to move or capture')

  local index = 41
  local gui_piece = newGuiPiece('C', index) gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)
  local gui_piece2 = newGuiPiece('S', 14) gui_piece2.setPosition(gui_board.points[14].x, gui_board.points[14].y)
  local gui_piece3 = newGuiPiece('s', 43) gui_piece3.setPosition(gui_board.points[43].x, gui_board.points[43].y)
  table.insert(gui_pieces, gui_piece)
  table.insert(gui_pieces, gui_piece2)
  table.insert(gui_pieces, gui_piece3)
  
  table.insert(yellow_circles, 5)
  table.insert(yellow_circles, 44)
  table.insert(yellow_circles, 45)

  nexter.visible = true
  nexter.buttons[1].fn = function() cannon3() end 
end

local function cannon1()
  clear('Cannons have the most confusing rules for movement. So remember 3 Things:')

  local index = 41
  local gui_piece = newGuiPiece('C', index)
  gui_piece.setPosition(gui_board.points[index].x, gui_board.points[index].y)
  table.insert(gui_pieces, gui_piece)

  nexter.visible = true
  nexter.buttons[1].fn = function() cannon2() end 
end

local btn_pieces = {}
table.insert(btn_pieces, newGuiPiece('S',1)) btn_pieces[1].setPosition(660, 80) btn_pieces[1].fn = function() soldier1()  end
table.insert(btn_pieces, newGuiPiece('H',2)) btn_pieces[2].setPosition(660,120) btn_pieces[2].fn = function() horse1()    end
table.insert(btn_pieces, newGuiPiece('C',3)) btn_pieces[3].setPosition(660,170) btn_pieces[3].fn = function() cannon1()   end
table.insert(btn_pieces, newGuiPiece('A',4)) btn_pieces[4].setPosition(730, 80) btn_pieces[4].fn = function() adviser1()  end
table.insert(btn_pieces, newGuiPiece('E',5)) btn_pieces[5].setPosition(730,120) btn_pieces[5].fn = function() elephant1() end
table.insert(btn_pieces, newGuiPiece('T',6)) btn_pieces[6].setPosition(730,170) btn_pieces[6].fn = function() chariot1()  end
table.insert(btn_pieces, newGuiPiece('G',7)) btn_pieces[7].setPosition(695,230) btn_pieces[7].fn = function() general1()  end

local function bikjang3()
  clear("#2 - Evade the offer altogether.")  
  table.insert(gui_pieces, newGuiPiece('g', 14))
  table.insert(gui_pieces, newGuiPiece('G', 87))
  table.insert(red_lines, {first = 87, last = 6})
  
  for _, v in pairs(gui_pieces) do
    v.setPosition(gui_board.points[v.index].x, gui_board.points[v.index].y)
  end

end

local function bikjang2()
  clear("Your opponent has 2 basic ways of rejecting this:\n#1 - Block the offer")
  table.insert(gui_pieces, newGuiPiece('g', 15))
  table.insert(gui_pieces, newGuiPiece('G', 87))
  table.insert(gui_pieces, newGuiPiece('s', 33))

  table.insert(lines, {first = 87, last = 33})
  table.insert(red_lines, {first = 33, last = 15})
  
  for _, v in pairs(gui_pieces) do
    v.setPosition(gui_board.points[v.index].x, gui_board.points[v.index].y)
  end
  nexter.visible = true
  nexter.buttons[1].fn = function() bikjang3() end 
end

local function bikjang1()
  clear("If you place your General in front your your opponent's General like this, you are offering a Draw.")
  table.insert(gui_pieces, newGuiPiece('g', 15))
  table.insert(gui_pieces, newGuiPiece('G', 87))
  table.insert(lines, {first = 15, last = 87})
  
  for _, v in pairs(gui_pieces) do
    v.setPosition(gui_board.points[v.index].x, gui_board.points[v.index].y)
  end
  nexter.visible = true
  nexter.buttons[1].fn = function() bikjang2() end 
end
local function otherStuff()
  clear("Since you can SKIP your turn, there's no such thing as STALEMATE in the game")
end

local menu = newGMenu()
menu.addButton('Exit Tutorial',    75,  15, function() state_machine.change(state_title) end)
menu.addButton('Piece Movements', 695,  43, function() soldier1()   end)
menu.addButton('Bikjang Rule',    695, 300, function() bikjang1()    end)
menu.addButton('Other Stuff',     695, 330, function() otherStuff() end)

function state_tutorial.load()
  otherStuff()
end

function state_tutorial.draw()
  love.graphics.setColor(1,1,0)
  for _, v in pairs(lines) do
    love.graphics.line(gui_board.points[v.first].x, gui_board.points[v.first].y, gui_board.points[v.last].x, gui_board.points[v.last].y)
  end
  
  love.graphics.setColor(1,0,0)
  for _, v in pairs(red_lines) do
    love.graphics.line(gui_board.points[v.first].x, gui_board.points[v.first].y, gui_board.points[v.last].x, gui_board.points[v.last].y)
  end
  
  love.graphics.setColor(1,1,1)
  for _, v in pairs(gui_pieces) do
    v.draw()
  end
  
  love.graphics.setColor(1,1,0,0.75)
  for _, v in pairs(yellow_circles) do
    love.graphics.circle('fill', gui_board.points[v].x, gui_board.points[v].y, radius)
  end
  
  love.graphics.setColor(1,0,0,0.75)
  for _, v in pairs(red_circles) do
    love.graphics.circle('fill', gui_board.points[v].x, gui_board.points[v].y, radius)
  end
  
  love.graphics.setColor(0,0,0,0.4)
  love.graphics.rectangle('fill', 160, 440, 280, 75, 4, 4)
  
  love.graphics.setColor(1,1,1)
  love.graphics.printf(text, 170, 450, 260, 'left')
  
  for _, v in pairs(btn_pieces) do
    v.draw()
  end
  
  menu.draw()
  if nexter.visible then nexter.draw() end
end

function state_tutorial.mousemoved(x, y, dx, dy)
  menu.mouse_over(x, y)
  if nexter.visible then nexter.mouse_over(x, y) end
end
function state_tutorial.mousepressed(x, y, button)
  if button == 1 then
    menu.button_press()
    if nexter.visible then nexter.button_press() end
    for _, v in pairs(btn_pieces) do
      if getCircleCircleDistance(x, y, nil, v.x, v.y, v.size/2) < 0 then
        v.fn()
      end
    end
  end
end
function state_tutorial.mousereleased(x, y, button)
  if button == 1 then
    menu.button_release()
    if nexter.visible then nexter.button_release() end
  end
end
