function newTimer(maintimer, byoyomitimer, periodcounter)
  local timer = { ended = false }
  local tick = 1
  local main = maintimer
  local byoyomi = byoyomitimer
  local periods = periodcounter
  
  function timer.update(dt)
    if not timer.ended then
      tick = tick - dt
    end
    if tick <= 0 then
      tick = 1
      if main > 0 then
        main = main - 1
      elseif byoyomi > 0 then
        byoyomi = byoyomi - 1
      elseif periods > 0 then
        byoyomi = byoyomitimer
        periods = periods - 1
      else
        timer.ended = true
      end
    end
  end
  
  function timer.main_text()
    local hour = math.floor(main/3600)
    local minute = math.floor((main-hour*3600)/60)
    local second = main%60
    hour = hour > 9 and hour or '0' .. hour
    minute = minute > 9 and minute or '0' .. minute
    second = second > 9 and second or '0' .. second
    return hour .. ':' .. minute .. ':' .. second
  end
  
  function timer.byoyomi_text()
    local minute = math.floor(byoyomi/3600)
    local second = byoyomi%60
    minute = minute > 9 and minute or '0' .. minute
    second = second > 9 and second or '0' .. second
    return minute .. ':' .. second
  end
  
  function timer.periods_text()
    local output = periods > 9 and periods or '0' .. periods
    return output
  end
  
  function timer.reset_byoyomi()
    tick = 1
    byoyomi = byoyomitimer
  end
  
  return timer
end
